﻿//     Copyright (c) Sitecore Corporation 1999-2015
/* jshint unused: vars */
var CommerceUtilities = CommerceUtilities || {};

CommerceUtilities.formatDateToLocale = function (elementId) {
    if (elementId) {
        var dateString = $(document.getElementById(elementId)).text();

        var formattedDate = CommerceUtilities.formatDateStringToLocale(dateString);

        $(document.getElementById(elementId)).text(formattedDate);
    }
},

CommerceUtilities.formatDateStringToLocale = function (dateString) {
    if (dateString) {
        // Expects date string to be in format yyyymmdd
        var year = dateString.substring(0, 4);
        var month = dateString.substring(4, 6);
        var day = dateString.substring(6);

        var date = new Date();
        date.setUTCFullYear(parseInt(year));
        date.setUTCMonth(parseInt(month) - 1);
        date.setUTCDate(parseInt(day));

        var formattedDate = date.toLocaleDateString();
        return formattedDate;
    }

    return null;
},

CommerceUtilities.formatInventoryDateString = function (dateString) {
    if (dateString) {
        // Expects date string to be in format yyyymmdd
        var year = dateString.substring(0, 4);
        var month = dateString.substring(4, 6);
        var day = dateString.substring(6);

        var formattedDate = month + "/" + day + "/" + year;
        return formattedDate;
    }

    return null;
},

CommerceUtilities.clickStream = function (elementId) {

    if (elementId) {
        var currentTarget = CommerceUtilities.loadPageVar("target");
        var currentPath = CommerceUtilities.loadPageVar("p");

        var base = "";

        if (currentPath) {
            base = $(document.getElementById(elementId)).attr('href') + "&p" + "=" + currentPath + "|" + elementId.split("_")[0];
        }
        else {
            if (!currentTarget) {
                base = $(document.getElementById(elementId)).attr('href') + "&p=" + elementId.split("_")[0];
            } else {
                var path = "";
                $(".commerce-breadcrumb").find("li").each(function () {
                    var hrefInToken = $(this).find("a").attr('href');
                    var targetInToken = CommerceUtilities.extractQuery(hrefInToken, "target");
                    var pathInToken = CommerceUtilities.extractQuery(hrefInToken, "p");
                    if (targetInToken) {
                        path += targetInToken + '|';
                    }
                    if (pathInToken) {
                        path += pathInToken + '|';
                    }

                });
                base = $(document.getElementById(elementId)).attr('href') + "&p=" + path + currentTarget + '|' + elementId.split("_")[0];
            }

        }

        $(document.getElementById(elementId)).attr('href', base);
        $(document.getElementById(elementId)).css('display', 'inline-block');
    }
}

CommerceUtilities.loadPageVar = function (sVar) {
    return unescape(window.location.search.replace(new RegExp("^(?:.*[&\\?]" + escape(sVar).replace(/[\.\+\*]/g, "\\$&") + "(?:\\=([^&]*))?)?.*$", "i"), "$1"));
}

CommerceUtilities.extractQuery = function (url, sVar) {
    return unescape(url.replace(new RegExp("^(?:.*[&\\?]" + escape(sVar).replace(/[\.\+\*]/g, "\\$&") + "(?:\\=([^&]*))?)?.*$", "i"), "$1"));
}

CommerceUtilities.formatProcessStatus = function (status) {
    if (status == "Error") {
        $("span[title='" + status + "']").addClass("dash-error");
        $("span[title='" + status + "']").prev().addClass("red");
    } else {
        if (status.indexOf('%') != -1) {
            var percentage = status.replace("%", "");
            var num = parseInt(percentage);
            if (num < 100) {
                $("span[title='" + status + "']").addClass("dash-percent");
                $("span[title='" + status + "']").prev().addClass("green");
            }

        }
    }
}

CommerceUtilities.createDelimitedListFromArray = function (arr, delimiter) {

    var delimitedList = "";
    if (!delimiter) {
        delimiter = "|";
    }

    if (arr && arr.length > 0) {

        for (i = 0; i < arr.length; i++) {
            if (delimitedList) {
                delimitedList += delimiter + arr[i];
            } else {
                delimitedList = arr[i];
            }
        }
    }

    return delimitedList;
}

CommerceUtilities.joinDelimitedLists = function (list1, list2, delimiter) {

    var joinedList = "";
    if (!delimiter) {
        delimiter = "|";
    }

    if (list1) {
        if (list2) {
            joinedList = list1 + delimiter + list2;
        } else {
            joinedList = list1;
        }
    } else {
        if (list2) {
            joinedList = list2;
        }
    }

    return joinedList;
}

CommerceUtilities.extractPropertyValues = function (itemList, propertyName) {

    var propertyValues = [];
    if (itemList && itemList.length > 0) {
        for (i = 0; i < itemList.length; i++) {
            propertyValues.push(itemList[i][propertyName]);
        }
    }

    return propertyValues;
}

CommerceUtilities.getUsersListViewPreference = function () {
    var viewMode = CommerceUtilities.getCookie("listViewMode");
    if (!viewMode) {
        return "DetailList";
    }

    return viewMode;
}

CommerceUtilities.setUsersListViewPreference = function (viewMode) {
    this.listViewMode = viewMode;
    document.cookie = 'listViewMode=' + viewMode;
}

CommerceUtilities.getCookie = function (name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');

    for (i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1, c.length);
        if (c.indexOf(nameEQ) === 0) return c.substring(nameEQ.length, c.length);
    }

    return null;
}