﻿//     Copyright (c) Sitecore Corporation 1999-2015
/* jshint unused: vars */
define(["sitecore"], function (Sitecore) {

    var model = Sitecore.Definitions.Models.ControlModel.extend({
        initialize: function (options) {
            this._super();
            this.set("value", "");
            this.set("formattedValue", "");
        }
    });

    var view = Sitecore.Definitions.Views.ControlView.extend({
        clientUpdatingFormattedValue: false,
        initialize: function (options) {
            this._super();
            this.model.on("change:value", this.formatValue, this);
            this.model.set("value", this.$el.attr("value"));
            this.model.on("change:formattedValue", this.resetValue, this);
        },

        formatValue: function () {
            if (!this.clientUpdatingFormattedValue) {
                var number = this.model.get("value");
                if (number !== "") {
                    this.model.set("formattedValue", parseFloat(Math.round(number * 100) / 100).toFixed(2));
                } else {
                    this.model.set("formattedValue", "");
                }
            }
        },

        resetValue: function () {
            this.clientUpdatingFormattedValue = true;
            this.model.set("value", this.model.get("formattedValue"));
            this.clientUpdatingFormattedValue = false;
        }
    });

    Sitecore.Factories.createComponent("CurrencyTextBox", model, view, ".sc-CurrencyTextBox");
});
